/*
 * @Author: your name
 * @Date: 2021-09-17 16:59:19
 * @LastEditTime: 2021-09-28 16:01:53
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /NOP_EHR/media/igs/xnm/ros/RM/roadmodel/modules/common/road/enum_list.h
 */
#pragma once
#include "stdint.h"
#include <vector>
#include <list>
#include <map>
// #include "mpc_drv_msgs/msg/control_waypoints.hpp"
#include "BA_Enum_List.h"
// #include "interface/slam_decision.h"
#include "dpc/impl_type_controlwaypoints.h"
#include "dpc/impl_type_linegeometry.h"
using namespace  dpc;
namespace BA
{
  struct Index
  {
    // passage ID, Node ID applied
    uint8_t m_X;
    uint8_t m_Y;
  };

  struct HV_Info
  {
    std::vector<float> m_DistanceAlongS;
    std::vector<float> m_Velocity;
    std::vector<uint8_t> m_LaneLocation; // lane ID
  };

  struct LongitudinalInfo
  {
    float m_DesiredDistance;
    float m_DesiredSpeed;
    float m_SetSpeed;
    float m_SetDistance;
    float m_YellowBorderDistance;
    float m_RedBorderDistance;
    uint8_t m_TargetObjID;
  };

  struct SLPoint
  {
    float s;
    float l;
  };

  // struct LineGeometry
  // {
  //   float m_LateralDeviation;
  //   float m_C1;
  //   float m_C2;
  //   float m_C3;
  //   float m_StartRange;
  //   float m_EndRange;
  //   float m_Confidence;
  // };

  struct LateralBorder
  {
    std::vector<SLPoint> m_LeftBorder;
    std::vector<SLPoint> m_RightBorder;
  };

  struct SpeedLimit
  {
    float m_TargetSpeed;
    float m_RelatedDistance;
  };

  struct LateralBlueCorridor
  {
    LineGeometry m_referenceLine;
    float m_Width;
  };

  struct LongitudinalCorridor
  {
    float m_CorridorDistance; // distance to vehicle
    float m_CorridorSpeed;
  };

  struct LaneTransitInfo
  {
    uint8_t m_ConnectedLaneID;
    TransitionTyp m_TransitTyp;
  };

  struct GlobalLaneInfo
  {
    // uint8_t m_LaneStartID;
    // uint8_t m_LaneEndID;
    uint8_t m_LaneID;
    std::vector<float> m_LastLaneChangePoint; 
    std::vector<float> m_DesiredLaneChangePoint;
    std::map<float, LaneTransitInfo> m_TransitOutInfo; // it denotes the first lane of two connected lanes
    std::map<float, LaneTransitInfo> m_TransitInInfo; // it denotes the second lane of two connected lanes
    uint8_t m_Priority;
  };

  struct GlobalInfoContainer
  {
    uint8_t m_WayPointID;
    float m_DistToWayPoint;
    std::vector<GlobalLaneInfo> m_GlobalLaneInfoArr;
    GlobalInfoSrc m_GlobalInfoSrc;
    LaneChgDrct m_GlobalLaneChgDrct;
    uint8_t m_GlobalLaneChgNum;
    std::vector<uint8_t> m_TgtLaneLst_CWP;
    std::vector<uint8_t> m_RawTgtLaneLst_CWP;
    std::vector<uint8_t> m_TgtLaneLst_RWP;
    TargetRoadTyp m_TgtRoadTyp_CWP;
    TargetRoadTyp m_TgtRoadTyp_RWP;
    uint8_t m_LftCrnrLaneID;
    uint8_t m_RghtCrnrLaneID;
    std::vector<WPExtendLaneStruct> m_WpExtendLaneLst;
    float m_SpeedLimit;
    RouteRltvPos m_RouteRltvPos;
    std::vector<uint8_t> m_MinLnGapTgtLaneLst;
  };

  struct HV_HistInfo
  {
    std::list<float> m_DistanceAlongS; // distance between ego veh and history point
    std::list<float> m_Velocity;
    std::list<uint8_t> m_LaneLocation;
    // std::list<uint8_t> m_LaneLocation {ADC::common::k_BA_HistVehInfoLstSize}; // lane ID
  };

  struct BoundaryIndex
  {
    // for new lane marker and lane boundary definition
    uint32_t m_LaneMarkerID;
    uint32_t m_LaneBoundaryID;
  };

  struct SignSpeedLimit
  {
    uint8_t m_SignSpdLmtID;
    float m_SignSpdLmtVal;
    float m_SignSpdLmtDist;
  };
  
}
